import Fanfou from './fanfou.js';
import * as api from './api.js';
import User from './user.js';
export declare type DirectMessageReplyOptions = {
    text: string;
    user?: string;
    inReplyToId?: string;
    mode?: api.APIMode;
    callback?: string;
};
export declare type DirectMessageDestroyOptions = {
    id?: string;
    callback?: string;
};
declare class DirectMessage {
    id: string;
    text: string;
    senderId: string;
    recipientId: string;
    createdAt: string;
    senderScreenName: string;
    recipientScreenName: string;
    sender: User;
    recipient: User;
    inReplyTo?: DirectMessage;
    private readonly ff;
    constructor(ff: Fanfou, dm: any);
    reply: (options: DirectMessageReplyOptions) => Promise<DirectMessage>;
    destroy: (options?: DirectMessageDestroyOptions | undefined) => Promise<DirectMessage>;
}
export default DirectMessage;
