import * as api from './api.js';
import User from './user.js';
class DirectMessage {
    constructor(ff, dm) {
        Object.defineProperty(this, "id", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "text", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "senderId", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "recipientId", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "createdAt", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "senderScreenName", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "recipientScreenName", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "sender", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "recipient", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "inReplyTo", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "ff", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "reply", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.createDirectMessage(this.ff, {
                user: this.senderId,
                inReplyToId: this.id,
                ...options
            })
        });
        Object.defineProperty(this, "destroy", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.dropDirectMessage(this.ff, {
                id: this.id,
                ...options
            })
        });
        this.ff = ff;
        this.id = dm.id;
        this.text = dm.text;
        this.senderId = dm.senderId;
        this.recipientId = dm.recipientId;
        this.createdAt = dm.createdAt;
        this.senderScreenName = dm.senderScreenName;
        this.recipientScreenName = dm.recipientScreenName;
        this.sender =
            dm.sender instanceof User ? dm.sender : new User(ff, dm.sender);
        this.recipient =
            dm.recipient instanceof User ? dm.recipient : new User(ff, dm.recipient);
        if (dm.inReplyTo) {
            this.inReplyTo =
                dm.inReplyTo instanceof DirectMessage
                    ? dm.inReplyTo
                    : new DirectMessage(ff, dm.inReplyTo);
        }
    }
}
export default DirectMessage;
