import * as api from './api.js';
import User from './user.js';
import Photo from './photo.js';
import { getEntities, getSourceUrl, getSourceName, getPlainText } from './utils.js';
class Status {
    constructor(ff, status) {
        Object.defineProperty(this, "createdAt", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "id", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "rawid", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "text", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "source", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "truncated", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "inReplyToStatusId", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "inReplyToUserId", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "inReplyToScreenName", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "inReplyToLastmsgId", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "favorited", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "isSelf", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "location", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "repostStatus", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "repostStatusId", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "repostUserId", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "repostScreenName", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "type", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "sourceUrl", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "sourceName", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "plainText", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "user", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "photo", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "entities", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "ff", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "reply", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.createStatus(this.ff, {
                inReplyToStatusId: this.id,
                ...options
            })
        });
        Object.defineProperty(this, "repost", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => {
                var _a;
                return api.createStatus(this.ff, {
                    repostStatusId: this.id,
                    status: (_a = options === null || options === void 0 ? void 0 : options.status) !== null && _a !== void 0 ? _a : '',
                    ...options
                });
            }
        });
        Object.defineProperty(this, "favorite", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.createFavorite(this.ff, {
                id: this.id,
                ...options
            })
        });
        Object.defineProperty(this, "unfavorite", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.dropFavorite(this.ff, {
                id: this.id,
                ...options
            })
        });
        Object.defineProperty(this, "destroy", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.dropStatus(this.ff, {
                id: this.id,
                ...options
            })
        });
        Object.defineProperty(this, "context", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.getContextTimeline(this.ff, {
                id: this.id,
                ...options
            })
        });
        this.ff = ff;
        this.createdAt = status.createdAt;
        this.id = status.id;
        this.rawid = status.rawid;
        this.text = status.text;
        this.source = status.source;
        this.truncated = status.truncated;
        this.favorited = status.favorited;
        if (status.inReplyToStatusId) {
            this.inReplyToStatusId = status.inReplyToStatusId;
        }
        if (status.inReplyToUserId) {
            this.inReplyToUserId = status.inReplyToUserId;
        }
        if (status.inReplyToScreenName) {
            this.inReplyToScreenName = status.inReplyToScreenName;
        }
        if (status.isSelf) {
            this.isSelf = status.isSelf;
        }
        if (status.location) {
            this.location = status.location;
        }
        if (status.repostStatusId) {
            this.repostStatusId = status.repostStatusId;
        }
        if (status.repostUserId) {
            this.repostUserId = status.repostUserId;
        }
        if (status.repostScreenName) {
            this.repostScreenName = status.repostScreenName;
        }
        if (status.repostStatus) {
            this.repostStatus =
                status.repostStatus instanceof Status
                    ? status.repostStatus
                    : new Status(ff, status.repostStatus);
        }
        if (status.user) {
            this.user =
                status.user instanceof User ? status.user : new User(ff, status.user);
        }
        if (status.photo) {
            this.photo =
                status.photo instanceof Photo ? status.photo : new Photo(status.photo);
        }
        this.type = this.getType();
        this.sourceUrl = getSourceUrl(status.source);
        this.sourceName = getSourceName(status.source);
        this.entities = getEntities(status.text);
        this.plainText = getPlainText(this.entities);
    }
    isReply() {
        return this.inReplyToStatusId !== '' || this.inReplyToUserId !== '';
    }
    isRepost() {
        return this.repostStatusId && this.repostStatusId !== '';
    }
    isOrigin() {
        return !(this.isReply() || this.isRepost());
    }
    isOriginRepost() {
        return this.isOrigin() && this.text.match(/转@/g);
    }
    getType() {
        if (this.isReply()) {
            return 'reply';
        }
        if (this.isRepost()) {
            return 'repost';
        }
        if (this.isOrigin()) {
            return 'origin';
        }
        return 'unknown';
    }
}
export default Status;
