import Fanfou from './fanfou.js';
import * as api from './api.js';
import Status from './status.js';
export declare type UserFollowOptions = {
    id?: string;
    mode?: api.APIMode;
};
export declare type UserUnfollowOptions = {
    id?: string;
    mode?: api.APIMode;
    format?: api.APIFormat;
    callback?: string;
};
export declare type UserBlockOptions = {
    id?: string;
    mode?: api.APIMode;
    format?: api.APIFormat;
    callback?: string;
};
export declare type UserUnblockOptions = {
    id?: string;
    mode?: api.APIMode;
};
export declare type UserCheckBlockOptions = {
    id?: string;
    mode?: api.APIMode;
};
export declare type UserTagsOptions = api.GetUserTagsOptions;
export declare type UserShowOptions = api.GetUserOptions;
export declare type UserTimelineOptions = api.GetUserTimelineOptions;
export declare type UserSearchTimelineOptions = api.SearchUserTimelineOptions;
export declare type UserRecentFollowersOptions = api.GetRecentFollowersOptions;
export declare type UserFollowersOptions = api.GetFollowersOptions;
export declare type UserFollowerIdsOptions = api.GetFollowerIdsOptions;
export declare type UserFollowingsOptions = api.GetFollowingsOptions;
export declare type UserFollowingIdsOptions = api.GetFollowingIdsOptions;
export declare type UserAcceptFriendshipOptions = {
    id?: string;
    mode?: api.APIMode;
    format?: api.APIFormat;
    callback?: string;
};
export declare type UserDenyFriendshipOptions = {
    id?: string;
    mode?: api.APIMode;
    format?: api.APIFormat;
    callback?: string;
};
declare class User {
    id: string;
    name: string;
    screenName: string;
    uniqueId: string;
    location: string;
    gender: string;
    birthday: string;
    description: string;
    profileImageUrl: string;
    profileImageUrlLarge: string;
    url: string;
    protected: boolean;
    followersCount: number;
    friendsCount: number;
    favouritesCount: number;
    statusesCount: number;
    photoCount: number;
    following: boolean;
    notifications: boolean;
    createdAt: string;
    utcOffset: number;
    profileImageOrigin?: string;
    profileImageOriginLarge?: string;
    profileBackgroundColor?: string;
    profileTextColor?: string;
    profileLinkColor?: string;
    profileSidebarFillColor?: string;
    profileSidebarBorderColor?: string;
    profileBackgroundImageUrl?: string;
    profileBackgroundTile?: boolean;
    status?: Status;
    private readonly ff;
    constructor(ff: Fanfou, user: any);
    follow: (options?: UserFollowOptions | undefined) => Promise<User>;
    unfollow: (options?: UserUnfollowOptions | undefined) => Promise<User>;
    block: (options?: UserBlockOptions | undefined) => Promise<User>;
    unblock: (options?: UserUnblockOptions | undefined) => Promise<User>;
    checkBlock: (options?: UserCheckBlockOptions | undefined) => Promise<User>;
    tags: (options?: api.GetUserTagsOptions | undefined) => Promise<string[]>;
    show: (options?: api.GetUserOptions | undefined) => Promise<User>;
    timeline: (options?: api.GetUserTimelineOptions | undefined) => Promise<Status[]>;
    searchTimeline: (options: UserSearchTimelineOptions) => Promise<Status[]>;
    recentFollowers: (options?: api.GetRecentFollowersOptions | undefined) => Promise<User[]>;
    followers: (options?: api.GetFollowersOptions | undefined) => Promise<User[]>;
    followerIds: (options?: api.GetFollowerIdsOptions | undefined) => Promise<string[]>;
    followings: (options?: api.GetFollowingsOptions | undefined) => Promise<User[]>;
    followingIds: (options?: api.GetFollowingIdsOptions | undefined) => Promise<string[]>;
    acceptFriendship: (options?: UserAcceptFriendshipOptions | undefined) => Promise<User>;
    denyFriendship: (options?: UserDenyFriendshipOptions | undefined) => Promise<User>;
}
export default User;
